// Note from MAXIMUS
// If anyone will change (or will add new) .label or (.id) - please
// be patient and add this label into RESOURCE\INI\TEXTS\(all languages)\interface_strings.txt
// It's VERY important for multilingual BUILD
void InitIslands()
{
	int		n, i;
	ISLANDS_QUANTITY = 0; // NK 05-03-30 use int and oversized array

	for (i=0; i<MAX_ISLANDS; i++)
	{
		DeleteAttribute(&Islands[i], "");

		Islands[i].id = "";
		Islands[i].reload_enable = true;
		Islands[i].visible = true;
	}

	// ==================================================================================================
	// Create temp module for enumerate locators
		object	locator;
		CreateEntity(&locator,"locator");


	// ==================================================================================================
	// Falaise de fleur
		n = 0;
		Islands[n].id = "FalaiseDeFleur";
//		Islands[n].worldmap = "FaleDeFler"; // NK 05-05-03
		Islands[n].model = "FalaiseDeFleur";
		Islands[n].filespath.models = "islands\FalaiseDeFleur";
		Islands[n].refl_model = "FalaiseDeFleur_refl";
		Islands[n].locators = "FalaiseDeFleur_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = FRANCE;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Falaise de Fleur";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Falaise_de_fleur_port_01";
		Islands[n].reload.l1.emerge = "sea";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Octopus Bay";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Falaise_de_Fleur_shore";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l3.name = "reload_fort1";
		Islands[n].reload.l3.go = "Fort"; // KK
		Islands[n].reload.l3.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l3.emerge = "see";
		Islands[n].reload.l3.radius = 250.0;
		Islands[n].reload.l3.commander = "FalaiseDeFleur Commander"; // KK
		Islands[n].reload.l3.fort.model = "FalaiseDeFleur_fort1";
		Islands[n].reload.l3.fort.locators = "FalaiseDeFleur_fort1_locators";
		Islands[n].reload.l3.pic = 1;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To
				
		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_7.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Export.id2 = GOOD_CHOCOLATE;
		Islands[n].Trade.Export.id3 = GOOD_LINEN;
		Islands[n].Trade.Export.id4 = GOOD_SILK;
		Islands[n].Trade.Export.id5 = GOOD_SILVER;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_EBONY;
		Islands[n].Trade.Import.id3 = GOOD_RUM;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Contraband.id1 = GOOD_SANDAL;
		Islands[n].Trade.Contraband.id2 = GOOD_FRUITS;
		Islands[n].Trade.Contraband.id3 = GOOD_CINNAMON;

		//breakpoint();
		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Redmond
		n = n + 1;
		Islands[n].id = "Redmond";
		Islands[n].model = "redmond";
		Islands[n].filespath.models = "islands\redmond";
		Islands[n].refl_model = "redmond_refl";
		Islands[n].locators = "redmond_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = ENGLAND;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Redmond";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_2";
		Islands[n].reload.l1.go = "REDMOND_PORT";
		Islands[n].reload.l1.emerge = "sea_1";
		Islands[n].reload.l1.radius = 600.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Devil's Throat";
		Islands[n].reload.l2.name = "reload_1";
		Islands[n].reload.l2.go = "Redmond_Shore_01";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Rocky Shore";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Redmond_Shore_02";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l4.name = "reload_fort1";
		Islands[n].reload.l4.go = "Fort"; // KK
		Islands[n].reload.l4.GoAfterBoard.location = "reload_2";
		Islands[n].reload.l4.emerge = "see";
		Islands[n].reload.l4.commander = "Redmond Commander"; // KK
		Islands[n].reload.l4.radius = 250.0;
		Islands[n].reload.l4.fort.model = "Redmond_fort1";
		Islands[n].reload.l4.fort.locators = "Redmond_fort1_locators";
		Islands[n].reload.l4.pic = 1;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_8.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Export.id2 = GOOD_LINEN;
		Islands[n].Trade.Export.id3 = GOOD_ALE;
		Islands[n].Trade.Export.id4 = GOOD_CLOTHES;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_CINNAMON;
		Islands[n].Trade.Import.id3 = GOOD_SILK;
		Islands[n].Trade.Import.id4 = GOOD_SANDAL;
		Islands[n].Trade.Contraband.id1 = GOOD_EBONY;
		Islands[n].Trade.Contraband.id2 = GOOD_COFFEE;
		Islands[n].Trade.Contraband.id3 = GOOD_PAPRIKA;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Isla Muelle
		n = n + 1;
		Islands[n].id = "IslaMuelle";
		Islands[n].model = "IslaMuelle";
		Islands[n].filespath.models = "islands\IslaMuelle";
		Islands[n].refl_model = "IslaMuelle_refl";
		Islands[n].locators = "IslaMuelle_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = SPAIN;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Isla Muelle";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Muelle_port";
		Islands[n].reload.l1.emerge = "Reload3";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		Islands[n].reload.l1.ships.l0.ay = 2.5;			// LDH fix until the locators.gm file can be updated - 24Apr09
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Shore";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Muelle_shore_02";
		Islands[n].reload.l2.emerge = "see";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.enable = false;
		Islands[n].reload.l2.pic = 3;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Oyster Beach";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Muelle_shore";
		Islands[n].reload.l3.emerge = "reload2";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 2;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l4.name = "reload_fort1";
		Islands[n].reload.l4.go = "Fort"; // KK
		Islands[n].reload.l4.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l4.emerge = "see";
		Islands[n].reload.l4.commander = "IslaMuelle Commander"; // KK
		Islands[n].reload.l4.radius = 250.0;
		Islands[n].reload.l4.fort.model = "IslaMuelle_fort1";
		Islands[n].reload.l4.fort.locators = "IslaMuelle_fort1_locators";
		Islands[n].reload.l4.pic = 1;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_4.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_EBONY;
		Islands[n].Trade.Export.id2 = GOOD_MAHOGANY;
		Islands[n].Trade.Export.id3 = GOOD_CINNAMON;
		Islands[n].Trade.Export.id4 = GOOD_SANDAL;
		Islands[n].Trade.Export.id5 = GOOD_GOLD;
		Islands[n].Trade.Export.id6 = GOOD_BRICKS;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_SUGAR;
		Islands[n].Trade.Import.id4 = GOOD_LINEN;
		Islands[n].Trade.Import.id5 = GOOD_SILVER;
		Islands[n].Trade.Import.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Contraband.id1 = GOOD_ALE;
		Islands[n].Trade.Contraband.id2 = GOOD_SILK;
		Islands[n].Trade.Contraband.id3 = GOOD_TOBACCO;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Oxbay
		n = n + 1;
		Islands[n].id = "Oxbay";
		Islands[n].model = "Oxbay";
		Islands[n].filespath.models = "islands\Oxbay";
		Islands[n].refl_model = "Oxbay_refl";
		Islands[n].locators = "Oxbay_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = ENGLAND;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Oxbay";
		Islands[n].towns.2 = "Greenford";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_2";
		Islands[n].reload.l1.go = "Oxbay_port";
		Islands[n].reload.l1.emerge = "reload2";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name# Port"; // KK
		Islands[n].reload.l2.name = "reload_1";
		Islands[n].reload.l2.go = "Greenford_port";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 1;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Gray Rock Bay";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Oxbay_shore_02";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 300.0;
		Islands[n].reload.l3.pic = 5;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Lighthouse";
		Islands[n].reload.l4.name = "reload_4";
		Islands[n].reload.l4.go = "Oxbay_lighthouse";
		Islands[n].reload.l4.emerge = "reload3";
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 6;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l5.label = "Far Beach";
		Islands[n].reload.l5.name = "reload_5";
		Islands[n].reload.l5.go = "Oxbay_Shore_01";
		Islands[n].reload.l5.emerge = "see";
		Islands[n].reload.l5.radius = 200.0;
		Islands[n].reload.l5.pic = 4;
		Islands[n].reload.l5.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l6.name = "reload_fort1";
		Islands[n].reload.l6.go = "Fort"; // KK
		Islands[n].reload.l6.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l6.emerge = "see";
		Islands[n].reload.l6.radius = 250.0;
		Islands[n].reload.l6.commander = "Greenford Commander"; // KK
		Islands[n].reload.l6.fort.model = "Oxbay_fort1";
		Islands[n].reload.l6.fort.locators = "Oxbay_fort1_locators";
		Islands[n].reload.l6.pic = 3;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l7.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l7.name = "reload_fort2";
		Islands[n].reload.l7.go = "Fort"; // KK
		Islands[n].reload.l7.GoAfterBoard.location = "reload_2";
		Islands[n].reload.l7.emerge = "see";
		Islands[n].reload.l7.commander = "Oxbay Commander"; // KK
		Islands[n].reload.l7.radius = 250.0;
		Islands[n].reload.l7.fort.model = "Oxbay_fort2";
		Islands[n].reload.l7.fort.locators = "Oxbay_fort2_locators";
		Islands[n].reload.l7.pic = 2;
		Islands[n].reload.l7.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l7.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_1.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 2;

		Islands[n].Trade.Export.id1 = GOOD_SANDAL;
		Islands[n].Trade.Export.id2 = GOOD_RUM;
		Islands[n].Trade.Export.id3 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id4 = GOOD_SILVER;
		Islands[n].Trade.Export.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id2 = GOOD_CHOCOLATE;
		Islands[n].Trade.Import.id3 = GOOD_SILK;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
		Islands[n].Trade.Contraband.id1 = GOOD_EBONY;
		Islands[n].Trade.Contraband.id2 = GOOD_COFFEE;
		Islands[n].Trade.Contraband.id3 = GOOD_PAPRIKA;
		Islands[n].Trade.Contraband.id4 = GOOD_BRICKS;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Conceicao
		n = n + 1;
		Islands[n].id = "Conceicao";
		Islands[n].model = "Conceicao";
		Islands[n].filespath.models = "islands\Conceicao";
		Islands[n].refl_model = "Conceicao_refl";
		Islands[n].locators = "Conceicao_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = PORTUGAL;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Conceicao";
		Islands[n].towns.2 = "Smugglers Lair";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Conceicao_port";
		Islands[n].reload.l1.emerge = "reload2";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		Islands[n].reload.l1.ships.l0.ay = 4.8;			// LDH fix until the locators.gm file can be updated - 24Apr09
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Sunny Haven";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Conceicao_shore_01";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Leviathan Rock";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Conceicao_shore_02";
		Islands[n].reload.l3.emerge = "see";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l4.name = "reload_fort1";
		Islands[n].reload.l4.go = "Fort"; // KK
		Islands[n].reload.l4.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l4.emerge = "see";
		Islands[n].reload.l4.radius = 250.0;
		Islands[n].reload.l4.commander = "Conceicao Commander"; // KK
		Islands[n].reload.l4.fort.locators = "Conceicao_fort1_locators";
		Islands[n].reload.l4.fort.model = "Conceicao_fort1";
		Islands[n].reload.l4.pic = 1;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_2.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Export.id2 = GOOD_SUGAR;
		Islands[n].Trade.Export.id3 = GOOD_CINNAMON;
		Islands[n].Trade.Export.id4 = GOOD_FRUITS;
		Islands[n].Trade.Import.id1 = GOOD_SILK;
		Islands[n].Trade.Import.id2 = GOOD_ALE;
		Islands[n].Trade.Import.id3 = GOOD_RUM;
		Islands[n].Trade.Import.id4 = GOOD_CHOCOLATE;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Import.id7 = GOOD_TREATMENT;
		Islands[n].Trade.Contraband.id1 = GOOD_WINE;
		Islands[n].Trade.Contraband.id2 = GOOD_MAHOGANY;
		Islands[n].Trade.Contraband.id3 = GOOD_COPRA;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Douwesen
		n = n + 1;
		Islands[n].id = "Douwesen";
		Islands[n].model = "Douwesen";
		Islands[n].filespath.models = "islands\Douwesen";
		Islands[n].refl_model = "Douwesen_refl";
		Islands[n].locators = "Douwesen_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = HOLLAND;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Douwesen";
		Islands[n].towns.2 = "Pirate Fort";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Douwesen_port";
		Islands[n].reload.l1.emerge = "reload2";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Palm Beach";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Douwesen_shore_01";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Crab Cliffs";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Douwesen_shore_02";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l4.name = "reload_fort1";
		Islands[n].reload.l4.go = "Fort"; // KK
		Islands[n].reload.l4.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l4.emerge = "see";
		Islands[n].reload.l4.radius = 250.0;
		Islands[n].reload.l4.commander = "Douwesen Commander"; // KK
		Islands[n].reload.l4.fort.model = "Douwesen_fort1";
		Islands[n].reload.l4.fort.locators = "Douwesen_fort1_locators";
		Islands[n].reload.l4.pic = 1;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_3.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id2 = GOOD_COFFEE;
		Islands[n].Trade.Export.id3 = GOOD_COPRA;
		Islands[n].Trade.Export.id4 = GOOD_ALE;
		Islands[n].Trade.Export.id5 = GOOD_FOOD;
		Islands[n].Trade.Export.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_WHEAT;
		Islands[n].Trade.Import.id4 = GOOD_RUM;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Contraband.id1 = GOOD_SUGAR;
		Islands[n].Trade.Contraband.id2 = GOOD_LINEN;
		Islands[n].Trade.Contraband.id3 = GOOD_WINE;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Quebradas
		n = n + 1;
		Islands[n].id = "QuebradasCostillas";
		Islands[n].model = "QuebradasCostillas";
		Islands[n].filespath.models = "islands\QuebradasCostillas";
		Islands[n].refl_model = "QuebradasCostillas_refl";
		Islands[n].locators = "QuebradasCostillas_locators";
		Islands[n].visible = true; // KK
		Islands[n].smuggling_nation = ENGLAND; // KK
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Charlestown";
		Islands[n].towns.2 = "Quebradas Costillas";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_2";
		Islands[n].reload.l1.go = "Charlestown_port";
		Islands[n].reload.l1.emerge = "reload1_back";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 6; // KK
		Islands[n].reload.l1.tex = "t2"; // KK
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name# Port"; // KK
		Islands[n].reload.l2.name = "reload_1";
		Islands[n].reload.l2.go = "QC_port";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 0;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "White bay";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "QC_Shore1";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 2;
		Islands[n].reload.l3.tex = "t3";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_6.tga";
		Islands[n].InterfaceTextures.t1.h = 4; // KK
		Islands[n].InterfaceTextures.t1.v = 1;

// KK -->
		Islands[n].InterfaceTextures.t2 = "battle_interface\moor_1.tga";
		Islands[n].InterfaceTextures.t2.h = 4;
		Islands[n].InterfaceTextures.t2.v = 2;

		Islands[n].InterfaceTextures.t3 = "battle_interface\moor_8.tga";
		Islands[n].InterfaceTextures.t3.h = 4;
		Islands[n].InterfaceTextures.t3.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_RUM;
		Islands[n].Trade.Export.id2 = GOOD_ALE;
		Islands[n].Trade.Export.id3 = GOOD_WINE;
		Islands[n].Trade.Export.id4 = GOOD_PLANKS;
		Islands[n].Trade.Import.id1 = GOOD_GOLD;
		Islands[n].Trade.Import.id2 = GOOD_SILVER;
		Islands[n].Trade.Import.id3 = GOOD_MAHOGANY;
		Islands[n].Trade.Import.id4 = GOOD_GUNPOWDER;
		Islands[n].Trade.Contraband.id1 = GOOD_EBONY;
		Islands[n].Trade.Contraband.id2 = GOOD_COFFEE;
		Islands[n].Trade.Contraband.id3 = GOOD_PAPRIKA;
// <-- KK

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Khael Roa
		n = n + 1;
		Islands[n].id = "KhaelRoa";
		Islands[n].model = "KhaelRoa";
		Islands[n].filespath.models = "islands\KhaelRoa";
		Islands[n].refl_model = "KhaelRoa_refl";
		Islands[n].locators = "KhaelRoa_locators";
		Islands[n].visible = false;
		Islands[n].Enc_enable = false;
		Islands[n].skipCR = true; // KK
		Islands[n].smuggling_nation = PIRATE;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Khael Roa";
		// NK <--

		Islands[n].reload.l1.label = "Khael Roa Shore";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "KhaelRoa_port";
		Islands[n].reload.l1.emerge = "Reload2";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.enable = false;
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_5.tga";
		Islands[n].InterfaceTextures.t1.h = 1;
		Islands[n].InterfaceTextures.t1.v = 1;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30


	// ==================================================================================================

	// ==================================================================================================
	// Cayman
		n = n + 1;
		Islands[n].id = "Cayman";
		Islands[n].model = "Cayman";
		Islands[n].filespath.models = "islands\Cayman";
		Islands[n].refl_model = "Cayman_refl";
		Islands[n].locators = "Cayman_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = ENGLAND;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Grand Cayman";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name#"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Cayman_port";
		Islands[n].reload.l1.emerge = "sea";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		Islands[n].reload.l1.ships.l0.ay = 1.7;			// LDH fix until the locators.gm file can be updated - 19Apr09
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Cayman Kai";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Cayman_Shore_02";
		Islands[n].reload.l2.emerge = "see"; // KK
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Sand Bluff";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Cayman_Shore_03";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Eden Rock";
		Islands[n].reload.l4.name = "reload_4";
		Islands[n].reload.l4.go = "Cayman_Shore_01";
		Islands[n].reload.l4.emerge = "reload1";
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 4;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

//		Islands[n].reload.l5.label = "reload 5";
//		Islands[n].reload.l5.name = "reload_5";
//		Islands[n].reload.l5.go = "";
//		Islands[n].reload.l5.emerge = "";
//		Islands[n].reload.l5.radius = 200.0;
//		Islands[n].reload.l5.pic = 5;
//		Islands[n].reload.l5.tex = "t1";
//		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l6.name = "reload1_2";
		Islands[n].reload.l6.go = "Fort"; // KK
		Islands[n].reload.l6.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l6.emerge = "see";
		Islands[n].reload.l6.radius = 250.0;
		Islands[n].reload.l6.commander = "Grand Cayman Commander"; // KK
		Islands[n].reload.l6.fort.model = "Cayman_fort2";
		Islands[n].reload.l6.fort.locators = "Cayman_fort2_locators";
		Islands[n].reload.l6.pic = 1;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_14.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 2;

		Islands[n].Trade.Export.id1 = GOOD_SANDAL;
		Islands[n].Trade.Export.id2 = GOOD_RUM;
		Islands[n].Trade.Export.id3 = GOOD_TOBACCO;
		Islands[n].Trade.Import.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id2 = GOOD_CHOCOLATE;
		Islands[n].Trade.Import.id3 = GOOD_SILK;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
		Islands[n].Trade.Contraband.id1 = GOOD_EBONY;
		Islands[n].Trade.Contraband.id2 = GOOD_COFFEE;
		Islands[n].Trade.Contraband.id3 = GOOD_PAPRIKA;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08


	// ==================================================================================================
	// Hispaniola (Gaity)
		n = n + 1;
		Islands[n].id = "Hispaniola";
		Islands[n].model = "Gaity";
		Islands[n].filespath.models = "islands\Gaity";
		Islands[n].refl_model = "Gaity_refl";
		Islands[n].locators = "Gaity_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = SPAIN;
		// NK -->
		Islands[n].towns.quantity = 3;
		Islands[n].towns.1 = "Port au Prince";
		Islands[n].towns.2 = "Santo Domingo";
		Islands[n].towns.3 = "Tortuga";
		Islands[n].towns.4 = "Buccaneers Camp"; // KK
		// NK <--

		Islands[n].reload.l1.label = "#stown_name#"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Hispaniola_port";
		Islands[n].reload.l1.emerge = "Reload2";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name#"; // KK
		Islands[n].reload.l2.name = "reload_3";
		Islands[n].reload.l2.go = "Santo_Domingo_port";
		Islands[n].reload.l2.emerge = "Reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "#stown_name# Port"; // KK
		Islands[n].reload.l3.name = "reload_7";
		Islands[n].reload.l3.go = "Tortuga_port";
		Islands[n].reload.l3.emerge = "Reload2";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 4;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Boca de Yuman";
		Islands[n].reload.l4.name = "reload_2";
		Islands[n].reload.l4.go = "Hispaniola_shore_01";
		Islands[n].reload.l4.emerge = "Reload1";
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 6;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l5.label = "Boca de Hubon";
		Islands[n].reload.l5.name = "reload_4";
		Islands[n].reload.l5.go = "Hispaniola_shore_02";
		Islands[n].reload.l5.emerge = "Reload1";
		Islands[n].reload.l5.radius = 200.0;
		Islands[n].reload.l5.pic = 8;
		Islands[n].reload.l5.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "Cape Francos";
		Islands[n].reload.l6.name = "reload_5";
		Islands[n].reload.l6.go = "Hispaniola_shore_03";
		Islands[n].reload.l6.emerge = "see";
		Islands[n].reload.l6.radius = 200.0;
		Islands[n].reload.l6.pic = 6;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l7.label = "Shore";
		Islands[n].reload.l7.name = "reload_9";
		Islands[n].reload.l7.go = "Hispaniola_shore_04";
		Islands[n].reload.l7.emerge = "Reload1";
		Islands[n].reload.l7.radius = 200.0;
		Islands[n].reload.l7.pic = 7;
		Islands[n].reload.l7.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l7.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l8.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l8.name = "reload1_2";
		Islands[n].reload.l8.go = "Fort"; // KK
		Islands[n].reload.l8.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l8.emerge = "see";
		Islands[n].reload.l8.radius = 250.0;
		Islands[n].reload.l8.commander = "Port au Prince Commander"; // KK
		Islands[n].reload.l8.fort.model = "Gaity_fort2";
		Islands[n].reload.l8.fort.locators = "Gaity_fort2_locators";
		Islands[n].reload.l8.pic = 1;
		Islands[n].reload.l8.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l8.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l9.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l9.name = "reload_8";
		Islands[n].reload.l9.go = "Fort"; // KK
		Islands[n].reload.l9.GoAfterBoard.location = "reload_3";
		Islands[n].reload.l9.emerge = "see";
		Islands[n].reload.l9.radius = 250.0;
		Islands[n].reload.l9.commander = "Santo Domingo Commander"; // KK
		Islands[n].reload.l9.fort.model = "Gaity_fort3";
		Islands[n].reload.l9.fort.locators = "Gaity_fort3_locators";
		Islands[n].reload.l9.pic = 3;
		Islands[n].reload.l9.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l9.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l10.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l10.name = "reload_6";
		Islands[n].reload.l10.go = "Fort"; // KK
		Islands[n].reload.l10.GoAfterBoard.location = "reload_7";
		Islands[n].reload.l10.emerge = "see";
		Islands[n].reload.l10.radius = 250.0;
		Islands[n].reload.l10.commander = "Tortuga Commander"; // KK
		Islands[n].reload.l10.fort.model = "Gaity_fort1";
		Islands[n].reload.l10.fort.locators = "Gaity_fort1_locators";
		Islands[n].reload.l10.pic = 5;
		Islands[n].reload.l10.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l10.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_12.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 4;

		Islands[n].Trade.Export.id1 = GOOD_EBONY;
		Islands[n].Trade.Export.id2 = GOOD_MAHOGANY;
		Islands[n].Trade.Export.id3 = GOOD_CINNAMON;
		Islands[n].Trade.Export.id4 = GOOD_SANDAL;
		Islands[n].Trade.Export.id5 = GOOD_GOLD;
		Islands[n].Trade.Export.id6 = GOOD_SILVER;               
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_SUGAR;
		Islands[n].Trade.Import.id4 = GOOD_LINEN;
		Islands[n].Trade.Import.id5 = GOOD_TREATMENT;
		Islands[n].Trade.Contraband.id1 = GOOD_ALE;
		Islands[n].Trade.Contraband.id2 = GOOD_SILK;
		Islands[n].Trade.Contraband.id3 = GOOD_TOBACCO;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

	// ==================================================================================================
	// Cuba
		n = n + 1;
		Islands[n].id = "Cuba";
		Islands[n].model = "Cuba";
		Islands[n].filespath.models = "islands\Cuba";
		Islands[n].refl_model = "Cuba_refl";
		Islands[n].locators = "Cuba_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = SPAIN;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Santiago";
		Islands[n].towns.2 = "Havana";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name#"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Santiago_port"; // KK
		Islands[n].reload.l1.emerge = "reload2"; // KK
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 2;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name#"; // KK
		Islands[n].reload.l2.name = "reload_3";
		Islands[n].reload.l2.go = "Cuba_Port";
		Islands[n].reload.l2.emerge = "sea_2";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 0;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

// KK -->
		Islands[n].reload.l3.label = "Bahia de San Antonio";
		Islands[n].reload.l3.name = "reload_2";
		Islands[n].reload.l3.go = "Cuba_shore_01";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 4;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Bahia de Moa";
		Islands[n].reload.l4.name = "reload_5";
		Islands[n].reload.l4.go = "Cuba_shore_02";
		Islands[n].reload.l4.emerge = "Reload2";
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 6;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l5.label = "Peninsula de Zapata";
		Islands[n].reload.l5.name = "reload_6";
		Islands[n].reload.l5.go = "Cuba_Shore_06";
		Islands[n].reload.l5.emerge = "Reload1";
		Islands[n].reload.l5.radius = 200.0;
		Islands[n].reload.l5.pic = 5;
		Islands[n].reload.l5.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "Punta de Maisi";
		Islands[n].reload.l6.name = "reload_7";
		Islands[n].reload.l6.go = "Cuba_Shore_03";
		Islands[n].reload.l6.emerge = "Reload1";
		Islands[n].reload.l6.radius = 200.0;
		Islands[n].reload.l6.pic = 4;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l7.label = "Playa de Sierra Maestra";
		Islands[n].reload.l7.name = "reload_8";
		Islands[n].reload.l7.go = "Cuba_Shore_05";
		Islands[n].reload.l7.emerge = "Reload1";
		Islands[n].reload.l7.radius = 200.0;
		Islands[n].reload.l7.pic = 7;
		Islands[n].reload.l7.tex = "t1";
		Islands[n].reload.l7.enable = false;
		Islands[n].reload.l7.goto_enable = false; // PB

		Islands[n].reload.l8.label = "Playa de Sabana";
		Islands[n].reload.l8.name = "reload_9";
		Islands[n].reload.l8.go = "Cuba_Shore_04";
		Islands[n].reload.l8.emerge = "Reload1";
		Islands[n].reload.l8.radius = 200.0;
		Islands[n].reload.l8.pic = 7;
		Islands[n].reload.l8.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l8.goto_enable = false; // Screwface: Disable Sail-To
// <-- KK

		Islands[n].reload.l9.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l9.name = "reload1_2";
		Islands[n].reload.l9.go = "Fort"; // KK
		Islands[n].reload.l9.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l9.emerge = "see";
		Islands[n].reload.l9.radius = 250.0;
		Islands[n].reload.l9.commander = "Santiago Commander"; // KK
		Islands[n].reload.l9.fort.model = "Cuba_fort2";
		Islands[n].reload.l9.fort.locators = "Cuba_fort2_locators";
		Islands[n].reload.l9.pic = 3;
		Islands[n].reload.l9.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l9.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l10.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l10.name = "reload_4";
		Islands[n].reload.l10.go = "Fort"; // KK
		Islands[n].reload.l10.GoAfterBoard.location = "reload_3";
		Islands[n].reload.l10.emerge = "see";
		Islands[n].reload.l10.radius = 250.0;
		Islands[n].reload.l10.commander = "Havana Commander"; // KK
		Islands[n].reload.l10.fort.model = "Cuba_fort1";
		Islands[n].reload.l10.fort.locators = "Cuba_fort1_locators";
		Islands[n].reload.l10.pic = 1;
		Islands[n].reload.l10.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l10.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_13.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 2;

		Islands[n].Trade.Export.id1 = GOOD_EBONY;
		Islands[n].Trade.Export.id2 = GOOD_MAHOGANY;
		Islands[n].Trade.Export.id3 = GOOD_CINNAMON;
		Islands[n].Trade.Export.id4 = GOOD_SANDAL;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_SUGAR;
		Islands[n].Trade.Import.id4 = GOOD_LINEN;
		Islands[n].Trade.Import.id5 = GOOD_TREATMENT;
		Islands[n].Trade.Contraband.id1 = GOOD_ALE;
		Islands[n].Trade.Contraband.id2 = GOOD_SILK;
		Islands[n].Trade.Contraband.id3 = GOOD_TOBACCO;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

	// ==================================================================================================
	// Guadeloupe
		n = n + 1;
		Islands[n].id = "Guadeloupe";
		Islands[n].model = "Guadelupa";
		Islands[n].filespath.models = "islands\Guadelupa";
		Islands[n].refl_model = "Guadelupa_refl";
		Islands[n].locators = "Guadelupa_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = FRANCE;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Pointe a Pitre";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name#"; // KK
		Islands[n].reload.l1.name = "reload_2";
		Islands[n].reload.l1.go = "Guadeloupe_Port";
		Islands[n].reload.l1.emerge = "reload2_back";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Anse Casse-Bois";
		Islands[n].reload.l2.name = "reload_3";
		Islands[n].reload.l2.go = "Guadeloupe_shore_01";
		Islands[n].reload.l2.emerge = "see";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l3.name = "reload_1";
		Islands[n].reload.l3.go = "Fort"; // KK
		Islands[n].reload.l3.GoAfterBoard.location = "reload_2";
		Islands[n].reload.l3.emerge = "see";
		Islands[n].reload.l3.radius = 250.0;
		Islands[n].reload.l3.commander = "Pointe a Pitre Commander"; // KK
		Islands[n].reload.l3.fort.model = "Guadelupa_fort1";
		Islands[n].reload.l3.fort.locators = "Guadelupa_fort1_locators";
		Islands[n].reload.l3.pic = 1;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_11.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Export.id2 = GOOD_CHOCOLATE;
		Islands[n].Trade.Export.id3 = GOOD_LINEN;
		Islands[n].Trade.Export.id4 = GOOD_SILK;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_EBONY;
		Islands[n].Trade.Import.id3 = GOOD_RUM;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Contraband.id1 = GOOD_SANDAL;
		Islands[n].Trade.Contraband.id2 = GOOD_FRUITS;
		Islands[n].Trade.Contraband.id3 = GOOD_CINNAMON;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

	// ==================================================================================================
	// Saint Martin (SENT)	// changed by ccc Feb 06
		n = n + 1;
		Islands[n].id = "SaintMartin";
		Islands[n].model = "sent";
		Islands[n].filespath.models = "islands\sent";
		Islands[n].refl_model = "sent_refl";
		Islands[n].locators = "sent_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = FRANCE;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Marigot";
		Islands[n].towns.2 = "Philipsburg";
		// NK <--

		Islands[n].reload.l5.label = "Fort St Louis";
		Islands[n].reload.l5.name = "reload_5";
		Islands[n].reload.l5.go = "Fort"; // KK
		Islands[n].reload.l5.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l5.emerge = "see";
		Islands[n].reload.l5.radius = 250.0;
		Islands[n].reload.l5.commander = "Marigot Commander"; // KK
		Islands[n].reload.l5.fort.model = "Sent_fort2";
		Islands[n].reload.l5.fort.locators = "Sent_fort2_locators";
		Islands[n].reload.l5.pic = 1;
		Islands[n].reload.l5.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "#stown_name#"; // KK
		Islands[n].reload.l6.name = "reload_3";
		Islands[n].reload.l6.go = "Marigot_port";
		Islands[n].reload.l6.emerge = "sea";
		Islands[n].reload.l6.radius = 200.0;
		Islands[n].reload.l6.pic = 0;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l10.label = "Fort Amsterdam";
		Islands[n].reload.l10.name = "reload1_2";
		Islands[n].reload.l10.go = "Fort"; // KK
		Islands[n].reload.l10.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l10.emerge = "see";
		Islands[n].reload.l10.radius = 250.0;
		Islands[n].reload.l10.commander = "Philipsburg Commander"; // KK
		Islands[n].reload.l10.fort.model = "Sent_fort1";
		Islands[n].reload.l10.fort.locators = "Sent_fort1_locators";
		Islands[n].reload.l10.pic = 1;
		Islands[n].reload.l10.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l10.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l11.label = "#stown_name#"; // KK
		Islands[n].reload.l11.name = "reload_1";
		Islands[n].reload.l11.go = "Philipsburg_port";
		Islands[n].reload.l11.emerge = "reload1";
		Islands[n].reload.l11.radius = 200.0;
		Islands[n].reload.l11.pic = 6;
		Islands[n].reload.l11.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l11.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Simpson Bay";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "SaintMartin_shore_01";
		Islands[n].reload.l2.emerge = "reload1";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 4;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Baie Orient";
		Islands[n].reload.l4.name = "reload_4";
		Islands[n].reload.l4.go = "SaintMartin_shore_02";
		Islands[n].reload.l4.emerge = "see";	// Akella's spelling ;)
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 2;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_14.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 2;

		Islands[n].Trade.Export.id1 = GOOD_SAILCLOTH;
		Islands[n].Trade.Export.id2 = GOOD_CHOCOLATE;
		Islands[n].Trade.Export.id3 = GOOD_LINEN;
		Islands[n].Trade.Export.id4 = GOOD_SILK;
		Islands[n].Trade.Export.id5 = GOOD_GOLD;
		Islands[n].Trade.Export.id6 = GOOD_SILVER;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_EBONY;
		Islands[n].Trade.Import.id3 = GOOD_RUM;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
		Islands[n].Trade.Contraband.id1 = GOOD_SANDAL;
		Islands[n].Trade.Contraband.id2 = GOOD_FRUITS;
		Islands[n].Trade.Contraband.id3 = GOOD_CINNAMON; // KK

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

	// ==================================================================================================
	// Antigua	changed by ccc Jan 06
		n = n + 1;
		Islands[n].id = "Antigua";
		Islands[n].model = "Antigua";
		Islands[n].filespath.models = "islands\Antigua";
		Islands[n].refl_model = "Antigua_refl";
		Islands[n].locators = "Antigua_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = ENGLAND;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "St John's";
		// NK <--

		Islands[n].reload.l1.label = "Fort James";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Fort"; // KK
		Islands[n].reload.l1.GoAfterBoard.location = "reload_2";
		Islands[n].reload.l1.emerge = "see";
		Islands[n].reload.l1.radius = 250.0;
		Islands[n].reload.l1.commander = "St John's Commander"; // KK
		Islands[n].reload.l1.fort.model = "Antigua_fort1";
		Islands[n].reload.l1.fort.locators = "Antigua_fort1_locators";
		Islands[n].reload.l1.pic = 1;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name#"; // KK
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Antigua_port";
		Islands[n].reload.l2.emerge = "sea_2";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 0;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Muscetto Cove";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Antigua_shore";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_10.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		// victualler stores only ship supplies
		Islands[n].Trade.Contraband.id1 = GOOD_CHOCOLATE;
		Islands[n].Trade.Contraband.id2 = GOOD_SILK;
		Islands[n].Trade.Contraband.id3 = GOOD_LEATHER;
		Islands[n].Trade.Contraband.id4 = GOOD_EBONY;
		Islands[n].Trade.Contraband.id5 = GOOD_COFFEE;
		Islands[n].Trade.Contraband.id6 = GOOD_PAPRIKA;
//		Islands[n].Trade.Contraband.id7 = GOOD_LEATHER;  //TALISMAN - Duplicate entry removed - following entries numbers reduced by 1
		Islands[n].Trade.Contraband.id7 = GOOD_SANDAL;
		Islands[n].Trade.Contraband.id8 = GOOD_FRUITS;
		Islands[n].Trade.Contraband.id9 = GOOD_CINNAMON
		Islands[n].Trade.Contraband.id10 = GOOD_TOBACCO;
		Islands[n].Trade.Contraband.id11 = GOOD_ALE;
		Islands[n].Trade.Contraband.id12 = GOOD_OIL;
		Islands[n].Trade.Contraband.id13 = GOOD_COPRA;
		Islands[n].Trade.Contraband.id14 = GOOD_WINE;
		Islands[n].Trade.Contraband.id15 = GOOD_MAHOGANY;
		Islands[n].Trade.Contraband.id16 = GOOD_SUGAR;
		Islands[n].Trade.Contraband.id17 = GOOD_COTTON;
		Islands[n].Trade.Contraband.id18 = GOOD_CLOTHES;
		Islands[n].Trade.Contraband.id19 = GOOD_LINEN;
		Islands[n].Trade.Contraband.id20 = GOOD_TREATMENT;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

	// ==================================================================================================
	// Turks
		n = n + 1;
		Islands[n].id = "Turks";
		Islands[n].model = "Terks";
		Islands[n].filespath.models = "islands\Terks";
		Islands[n].refl_model = "Terks_refl";
		Islands[n].locators = "Terks_locators";
		Islands[n].visible = true;
		Islands[n].Enc_enable = false;
		Islands[n].smuggling_nation = PIRATE;
// KK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Grand Turk";
// KK <--

		Islands[n].reload.l1.label = "#stown_name#"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Turks_Port";
		Islands[n].reload.l1.emerge = "Reload1";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Turtle Bay";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Turks_Lighthouse";
		Islands[n].reload.l2.emerge = "reload3";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "White reefs";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Turks_shore_01";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 4;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l4.label = "Sandy Point";
		Islands[n].reload.l4.name = "reload_4";
		Islands[n].reload.l4.go = "Turks_Shore_04";
		Islands[n].reload.l4.emerge = "reload3";
		Islands[n].reload.l4.radius = 200.0;
		Islands[n].reload.l4.pic = 3;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l5.label = "Birds Cove";
		Islands[n].reload.l5.name = "reload_5";
		Islands[n].reload.l5.go = "Turks_shore_05";
		Islands[n].reload.l5.emerge = "see";
		Islands[n].reload.l5.radius = 200.0;
		Islands[n].reload.l5.pic = 5;
		Islands[n].reload.l5.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l5.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l6.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l6.name = "reload1_2";
		Islands[n].reload.l6.go = "Fort"; // KK
		Islands[n].reload.l6.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l6.emerge = "see";
		Islands[n].reload.l6.radius = 250.0;
		Islands[n].reload.l6.commander = "Grand Turk Commander"; // KK
		Islands[n].reload.l6.fort.model = "Terks_fort1";
		Islands[n].reload.l6.fort.locators = "Terks_fort1_locators";
		Islands[n].reload.l6.pic = 1;
		Islands[n].reload.l6.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l6.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_14.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 2;

// KK -->
		Islands[n].Trade.Export.id1 = GOOD_COPRA;
		Islands[n].Trade.Export.id2 = GOOD_SILK;
		Islands[n].Trade.Export.id3 = GOOD_COFFEE;
		Islands[n].Trade.Export.id4 = GOOD_FRUITS;
		Islands[n].Trade.Import.id1 = GOOD_OIL;
		Islands[n].Trade.Import.id2 = GOOD_ALE;
		Islands[n].Trade.Import.id3 = GOOD_TOBACCO;
		Islands[n].Trade.Import.id4 = GOOD_LEATHER;
// <-- KK

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08

// KK -->
	// ==================================================================================================
	// Curacao
		n = n + 1;
		Islands[n].id = "Curacao";
		Islands[n].model = "Curacao";
		Islands[n].filespath.models = "islands\Curacao";
		Islands[n].refl_model = "Curacao_refl";
		Islands[n].locators = "Curacao_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = HOLLAND;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Willemstad";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port"; // KK
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Willemstad_port";
		Islands[n].reload.l1.emerge = "sea";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		Islands[n].reload.l1.ships.l0.ay = 3.14;		// LDH fix until the locators.gm file can be updated - 19Apr09
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Bullen Bay";
		Islands[n].reload.l2.name = "reload_2";
		Islands[n].reload.l2.go = "Curacao_shore_01";
		Islands[n].reload.l2.emerge = "see";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 2;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "Bocht Van Hato";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Curacao_shore_02";
		Islands[n].reload.l3.emerge = "reload1";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 3;
		Islands[n].reload.l3.tex = "t1";
		Islands[n].reload.l3.enable = false;
		Islands[n].reload.l3.goto_enable = false; // PB

		/*Islands[n].reload.l4.label = "#stown_name# Fort"; // KK
		Islands[n].reload.l4.name = "reload_fort1";
		Islands[n].reload.l4.go = "Fort"; // KK
		Islands[n].reload.l4.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l4.emerge = "see";
		Islands[n].reload.l4.radius = 250.0;
		Islands[n].reload.l4.commander = "Douwesen Commander"; // KK
		Islands[n].reload.l4.fort.model = "Douwesen_fort1";
		Islands[n].reload.l4.fort.locators = "Douwesen_fort1_locators";
		Islands[n].reload.l4.pic = 1;
		Islands[n].reload.l4.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l4.goto_enable = false; // Screwface: Disable Sail-To*/

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_3.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id2 = GOOD_COFFEE;
		Islands[n].Trade.Export.id3 = GOOD_COPRA;
		Islands[n].Trade.Export.id4 = GOOD_ALE;
		Islands[n].Trade.Export.id5 = GOOD_FOOD;
		Islands[n].Trade.Export.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_WHEAT;
		Islands[n].Trade.Import.id4 = GOOD_WINE;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Contraband.id1 = GOOD_SUGAR;
		Islands[n].Trade.Contraband.id2 = GOOD_LINEN;
		Islands[n].Trade.Contraband.id3 = GOOD_RUM;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Eleuthera
		n = n + 1;
		Islands[n].id = "Eleuthera";
		Islands[n].model = "Eleuthera";
		Islands[n].filespath.models = "islands\Eleuthera";
		Islands[n].refl_model = "Eleuthera_refl";
		Islands[n].locators = "Eleuthera_locators";
		Islands[n].visible = true;
		if(bUSAExists) Islands[n].smuggling_nation = ENGLAND;
		else Islands[n].smuggling_nation = ENGLAND;
		// NK -->
		Islands[n].towns.quantity = 2;
		Islands[n].towns.1 = "Eleuthera";
		Islands[n].towns.2 = "Alice";
		// NK <--

		Islands[n].reload.l1.label = "#stown_name# Port";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Eleuthera_Port";
		Islands[n].reload.l1.emerge = "reload1";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "#stown_name# Fort";
		Islands[n].reload.l2.name = "reload_fort1";
		Islands[n].reload.l2.go = "Fort"; // KK
		Islands[n].reload.l2.GoAfterBoard.location = "reload_1";
		Islands[n].reload.l2.emerge = "see";
		Islands[n].reload.l2.radius = 250.0;
		Islands[n].reload.l2.commander = "Eleuthera Commander";
		Islands[n].reload.l2.fort.model = "Eleuthera_fort1";
		Islands[n].reload.l2.fort.locators = "Eleuthera_fort1_locators";
		Islands[n].reload.l2.pic = 1;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l3.label = "#stown_name# Port";
		Islands[n].reload.l3.name = "reload_3";
		Islands[n].reload.l3.go = "Alice";
		Islands[n].reload.l3.emerge = "reload61";
		Islands[n].reload.l3.radius = 200.0;
		Islands[n].reload.l3.pic = 0;
		Islands[n].reload.l3.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l3.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_3.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		/* TALISMAN - Eleuthera - no beach for smugglers - remove contraband
		Islands[n].Trade.Export.id1 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id2 = GOOD_COFFEE;
		Islands[n].Trade.Export.id3 = GOOD_COPRA;
		Islands[n].Trade.Export.id4 = GOOD_ALE;
		Islands[n].Trade.Export.id5 = GOOD_FOOD;
		Islands[n].Trade.Export.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_WHEAT;
		Islands[n].Trade.Import.id4 = GOOD_WINE;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Contraband.id1 = GOOD_SUGAR;
		Islands[n].Trade.Contraband.id2 = GOOD_LINEN;
		Islands[n].Trade.Contraband.id3 = GOOD_RUM;
*/
// TALISMAN - reassign goods
		Islands[n].Trade.Export.id1 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id2 = GOOD_COFFEE;
		Islands[n].Trade.Export.id3 = GOOD_COPRA;
		Islands[n].Trade.Export.id4 = GOOD_ALE;
		Islands[n].Trade.Export.id5 = GOOD_FOOD;
		Islands[n].Trade.Export.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Export.id7 = GOOD_RUM;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_WHEAT;
		Islands[n].Trade.Import.id4 = GOOD_WINE;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Import.id7 = GOOD_SUGAR;
		
		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// Aruba
		n = n + 1;
		Islands[n].id = "Aruba";
		Islands[n].model = "Aruba";
		Islands[n].filespath.models = "islands\Aruba";
		Islands[n].refl_model = "Aruba_refl";
		Islands[n].locators = "Aruba_locators";
		Islands[n].visible = true;
		Islands[n].smuggling_nation = HOLLAND;
		// NK -->
		Islands[n].towns.quantity = 1;
		Islands[n].towns.1 = "Oranjestad";
		// NK <--

		/*Islands[n].reload.l1.label = "#stown_name# Fort";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Fort"; // KK
		Islands[n].reload.l1.GoAfterBoard.location = "reload_2";
		Islands[n].reload.l1.emerge = "see";
		Islands[n].reload.l1.radius = 250.0;
		Islands[n].reload.l1.commander = "Oranjestad Commander"; // KK
		Islands[n].reload.l1.fort.model = "Aruba_fort1";
		Islands[n].reload.l1.fort.locators = "Aruba_fort1_locators";
		Islands[n].reload.l1.pic = 1;
		Islands[n].reload.l1.tex = "t1";
		Islands[n].reload.l1.ships.l0.x = -5.0;
		Islands[n].reload.l1.ships.l0.z = -150.0;
		Islands[n].reload.l1.ships.l0.ay = 0.0;
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To*/

		Islands[n].reload.l1.label = "#stown_name# Port";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "Oranjestad_port";
		Islands[n].reload.l1.emerge = "reload1";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l1.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].reload.l2.label = "Rocky Cove";
		Islands[n].reload.l2.name = "reload_3";
		Islands[n].reload.l2.go = "Aruba_shore";
		Islands[n].reload.l2.emerge = "see";
		Islands[n].reload.l2.radius = 200.0;
		Islands[n].reload.l2.pic = 3;
		Islands[n].reload.l2.tex = "t1";
		if(!bArcadeMode) Islands[n].reload.l2.goto_enable = false; // Screwface: Disable Sail-To

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_10.tga";
		Islands[n].InterfaceTextures.t1.h = 4;
		Islands[n].InterfaceTextures.t1.v = 1;

		Islands[n].Trade.Export.id1 = GOOD_TOBACCO;
		Islands[n].Trade.Export.id2 = GOOD_COFFEE;
		Islands[n].Trade.Export.id3 = GOOD_COPRA;
		Islands[n].Trade.Export.id4 = GOOD_ALE;
		Islands[n].Trade.Export.id5 = GOOD_FOOD;
		Islands[n].Trade.Export.id6 = GOOD_TREATMENT;
		Islands[n].Trade.Import.id1 = GOOD_PLANKS;
		Islands[n].Trade.Import.id2 = GOOD_SAILCLOTH;
		Islands[n].Trade.Import.id3 = GOOD_WHEAT;
		Islands[n].Trade.Import.id4 = GOOD_WINE;
		Islands[n].Trade.Import.id5 = GOOD_GOLD;
		Islands[n].Trade.Import.id6 = GOOD_SILVER;
		Islands[n].Trade.Contraband.id1 = GOOD_SUGAR;
		Islands[n].Trade.Contraband.id2 = GOOD_LINEN;
		Islands[n].Trade.Contraband.id3 = GOOD_RUM;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-04-08
// <-- KK

	// ==================================================================================================
	// Isla Mona
		n = n + 1;
		Islands[n].id = "IslaMona";
		Islands[n].model = "islamona";
		Islands[n].filespath.models = "islands\IslaDeMuerte";
		Islands[n].refl_model = "islamona_refl";
		Islands[n].locators = "islamona_locators";
		Islands[n].visible = false;
		Islands[n].Enc_enable = false;
		Islands[n].skipCR = true; // KK
		Islands[n].smuggling_nation = ENGLAND;
		Islands[n].towns.quantity = 10;//Cities - way for adding new model into the WorldMap

		Islands[n].reload.l1.label = "Isla Mona Shore";
		Islands[n].reload.l1.name = "reload_1";
		Islands[n].reload.l1.go = "IslaMona_port";
		Islands[n].reload.l1.emerge = "Reload3";
		Islands[n].reload.l1.radius = 200.0;
		Islands[n].reload.l1.enable = false;
		Islands[n].reload.l1.goto_enable = false; // PB
		Islands[n].reload.l1.pic = 0;
		Islands[n].reload.l1.tex = "t1";

		Islands[n].InterfaceTextures.t1 = "battle_interface\moor_5.tga";
		Islands[n].InterfaceTextures.t1.h = 1;
		Islands[n].InterfaceTextures.t1.v = 1;

		SendMessage(&locator,"le",LM_LOCATE_I,&Islands[n]);
		ISLANDS_QUANTITY = n+1; // NK 05-03-30

	// ==================================================================================================
	// delete temp module
		DeleteClass(&locator);
}
